#ifndef VEC3_H
#define VEC3_H

template <typename T> struct Vec3 {
  T x;
  T y;
  T z;

  inline Vec3<T> operator+(Vec3<T> other) const {
    return {x + other.x, y + other.y, z + other.z};
  };

  inline Vec3<T> operator-(Vec3<T> other) const {
    return {x - other.x, y - other.y, z - other.z};
  };

  inline void scale(T scalar) {
    x *= scalar;
    y *= scalar;
    z *= scalar;
  };

  inline T dot(Vec3<T> other) {
    return x * other.x + y * other.y + z * other.z;
  }

  inline Vec3<T> cross(Vec3<T> other) {
    return {y * other.z - z * other.y, z * other.x - x * other.z,
            x * other.y - y * other.x};
  }
};

#endif
